%% 2d traj
close all
clear
clc
lambda=0.5;
p=1; % number of continous derivatives - 1
n=2; % dim
s=tf('s');
W.xy = [0 10 20 30 30 20 10 0;0 -10 0 0 10 10 10 0]; %waypoints
W.t = [10 20 30 40 50 55 60 70]*0.1; 
Ts=0.1;
t=1:Ts:7;

%%------------- cont -------------
A=[zeros(n,n) eye(n,n) zeros(n,n);zeros(n,n) zeros(n,n) eye(n,n);zeros(n,n) zeros(n,n) zeros(n,n)];
B=[zeros(n,n); zeros(n,n); eye(n,n)];
C=[eye(n,n) zeros(n,n) zeros(n,n)];
D=0;

%%------------- add p int -------------
if p>0
A=[A B zeros(3*n,n*(p-1));zeros(n*(p-1),3*n+n) eye(n*(p-1),n*(p-1));zeros(n,3*n+n*p)]; %*(p-1)
B=[zeros(3*n+n*(p-1),n);eye(n,n)];
C=[C zeros(n,p*n)];
D=zeros(n,n);
end    
sysc=ss(A,B,C,D);

%%------------- disc -------------
sysd_imp=c2d(sysc,Ts,'imp');

%%------------- trajson -------------
[x v]= trajson(sysd_imp,W,lambda,t);

%%------------- plot -------------
figure(1)
plot(x(1,:),x(2,:),'linewidth',3,'color',[0.5 0.5 0.5]*0)
hold on
plot(W.xy(1,:),W.xy(2,:),'o','MarkerEdgeColor','k','MarkerFaceColor','k','MarkerSize',8)
xlabel('x-position','FontSize',14)
ylabel('y-position','FontSize',14)
figure(2)
plot(t,x(3*n+1,1:end),'linewidth',3,'color',[0.5 0.5 0.5]*0)
hold on
plot(t,x(3*n+2,1:end),'linewidth',3,'color',[0.5 0.5 0.5])
ylabel('u','FontSize',14);xlabel('t','FontSize',14)
figure(3)
plot(t(2:end),v(1,:),'s','MarkerEdgeColor',[0.5 0.5 0.5]*0,'MarkerFaceColor',[0.5 0.5 0.5]*0,'MarkerSize',6)
hold on
plot(t(2:end),v(2,:),'o','MarkerEdgeColor','k','MarkerFaceColor','k','MarkerSize',6)
ylabel('v','FontSize',14);xlabel('t','FontSize',14)


